package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Are Andreas Lomås (Materie)
	 */
	 
	 
	public class Player extends Entity
	{
		[Embed(source = "assets/caveman_spritemap_crystal.png")] public static const SPR_MAP_PLAYER:Class;
		
		private var sprite:Spritemap = new Spritemap(SPR_MAP_PLAYER, 25, 70);;
		
		public function Player(x:int,y:int)
		{
			super(x, y, sprite);
			
			sprite.add("idle", [4], 0, false);
			sprite.add("walk", [0, 1, 2, 1, 0, 3, 2, 3], 6, true);
			
			sprite.centerOO();
			setHitbox(sprite.width, sprite.height, sprite.width/2, sprite.height/2);
			type = "player";
		}
		
		override public function added():void
		{
			sprite.play("idle");
		}
		
		override public function update():void
		{
			if (Input.check(Key.LEFT) && !Input.check(Key.RIGHT))
			{
				sprite.flipped = true;
				sprite.play("walk");
				x -= FP.elapsed * 60;
				layer = -20;
			}
			else if (Input.check(Key.RIGHT) && !Input.check(Key.LEFT))
			{
				sprite.flipped = false;
				sprite.play("walk");
				x += FP.elapsed * 60;
			}
			else if (Input.check(Key.X))
			{
				
			}
			else if (Input.check(Key.Z))
			{
				
			}
			else
			{
				sprite.play("idle");
			}
		}
	}

}