package  
{
	import flash.net.FileReference;
	import net.flashpunk.Entity;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	import levels.GameOver;
	import levels.Level2;
	
	import flash.utils.getQualifiedClassName;
	import flash.utils.getDefinitionByName;
	
	/**
	 * ...
	 * @author Are Andreas Lomås (Materie)
	 */
	 
	 
	public class Tree extends Entity
	{
		[Embed(source = "assets/tree.png")] public static const SPR_TREE:Class;
		[Embed(source = "assets/lightning.png")] public static const SPR_LIGHTNING:Class;
		
		private var sprite:Image = new Image(SPR_TREE);
		private var lightning:Entity;
		
		private var lightningTimeLeft:int = 400;
		
		private var activated:Boolean = false;
		
		private var pressAlertText:Text = new Text("Press 'X' to interact.", 0, 0, { size: 8, color: 0xFFFFFF, width: 150, wordWrap: true } );
		public var pressAlertEntity:Entity;
		
		public function Tree(x:int,y:int)
		{
			super(x, y, sprite);
			
			layer = 10;
			sprite.centerOO();
			setHitbox(sprite.width * 2, sprite.height * 2, sprite.width, sprite.height); //don't need to actually TOUCH the tree to have it get struck
			//pressAlertText.centerOO();
		}
		
		override public function added():void
		{
			
		}
		
		override public function update():void
		{
			if (collide("player", x, y) && !activated)
			{
				lightning = FP.world.addGraphic(new Image(SPR_LIGHTNING), -100, x, 0);
				trace("Tree activated!");
				activated = true;
			}
			
			if (lightningTimeLeft > 0 && activated)
			{
				lightningTimeLeft -= int(FP.elapsed*1000);
				trace(lightningTimeLeft, int(FP.elapsed*1000));
			}
			
			if (lightningTimeLeft <= 0 && activated)
			{
				if (lightning)
				{
					FP.world.remove(lightning);
					trace("removed lightning!");
					lightning = null;
					FP.world.add(new Flame(x + 2, 120,0));
					FP.world.add(new Flame(x - 4, 140,1));
					FP.world.add(new Flame(x + 7, 180,2));
				}
				
				if (collide("player", x, y))
				{
					if (pressAlertEntity == null)
					{
						pressAlertEntity = FP.world.add(new Entity(x - 50, 120, pressAlertText));
					}
					
					if (Input.check(Key.X))
					{
						FP.world = new Level2;
					}
				}
				else
				{
					if (pressAlertEntity != null)
					{
						FP.world.remove(pressAlertEntity);
						pressAlertEntity = null;
					}
				}
			}
		}
	}
	


}