package levels 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author Are Andreas Lomås (Materie)
	 */
	public class GameOver extends World
	{
		public var lastWorld:Class;
		
		public function GameOver(lastWorld:Class)
		{
			this.lastWorld = lastWorld;
		}
		
		override public function begin():void
		{
			var gameoverText:Text = new Text("You have died!", 0, -40, {size: 24, color: 0xFF0000});
			gameoverText.centerOrigin();
			FP.world.add(new Entity(FP.screen.width / 2, FP.screen.height / 2, gameoverText));
			
			var restartText:Text = new Text("Press X to try again!", 0, 30, {size: 16, color: 0xFF0000});
			restartText.centerOrigin();
			FP.world.add(new Entity(FP.screen.width / 2, FP.screen.height / 2, restartText));
			
			var menuText:Text = new Text("Press Z to quit!", 0, 60, {size: 16, color: 0xFF0000});
			menuText.centerOrigin();
			FP.world.add(new Entity(FP.screen.width/2, FP.screen.height/2, menuText));
		}
		
		override public function update():void
		{
			super.update();
			
			if (Input.check(Key.X))
			{
				FP.world = new lastWorld;
			}
			
			if (Input.check(Key.Z))
			{
				FP.world = new Title;
			}
		}
	}

}