package levels 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Are Andreas Lomås (Materie)
	 */
	public class StoneAge extends World
	{
		[Embed(source = "../assets/ground.png")] public static const SPR_GROUND:Class;
		[Embed(source = "../assets/background_1_final.png")] public static const SPR_BG1:Class;
		[Embed(source = "../assets/background_2_final.png")] public static const SPR_BG2:Class;
		[Embed(source = "../assets/background_3_fix_cut.png")] public static const SPR_BG3:Class;
		[Embed(source = "../assets/moon.png")] public static const SPR_MOON:Class;
		[Embed(source = "../assets/stars.png")] public static const SPR_STARS:Class;
		
		public var ground:Backdrop;
		public var bg1:Backdrop;
		public var bg2:Backdrop;
		public var bg3:Backdrop;
		public var moon:Backdrop;
		public var stars:Backdrop;
		
		public var player:Entity;
		
		public var levelDescription:Text = new Text("It's cold and dark. I need some way to keep warm in the night.", 0, 0, { size: 8, color: 0xFFFFFF, width: 150, wordWrap: true } );
		public var levelDescriptionEntity:Entity;
		
		public var levelDescriptionTimeLeft:int = 5000; //milliseconds
		
		override public function begin():void
		{
			ground = new Backdrop(SPR_GROUND, true, false);
			ground.scrollX = 1;
			addGraphic(ground, 10);
			ground.y = 170;
			bg1 = new Backdrop(SPR_BG1, true, false);
			bg1.scrollX = 0.9;
			addGraphic(bg1, 20);
			bg2 = new Backdrop(SPR_BG2, true, false);
			bg2.scrollX = 0.7;
			addGraphic(bg2, 30);
			bg3 = new Backdrop(SPR_BG3, true, false);
			bg3.scrollX = 0.1;
			addGraphic(bg3, 40);
			moon = new Backdrop(SPR_MOON, false, false);
			moon.x = 200;
			moon.y = 40;
			moon.scrollX = 0;
			addGraphic(moon, 50);
			stars = new Backdrop(SPR_STARS, false, false);
			stars.scrollX = 0;
			addGraphic(stars, 60);
			player = add(new Player(150, 190));
			add(new Wolf( -150, 210));
			add(new Tree( 470, 170));
			levelDescription.centerOO();
			levelDescriptionEntity = add(new Entity(FP.screen.width / 2, FP.screen.height / 2, levelDescription));
		}
		
		override public function update():void
		{
			super.update();
			
			if (levelDescriptionTimeLeft > 0)
			{
				levelDescriptionTimeLeft -= FP.elapsed * 1000;
			}
			else
			{
				if (levelDescriptionEntity)
				{
					FP.world.remove(levelDescriptionEntity);
					levelDescriptionEntity = null;
				}
			}
			
			FP.camera.x = player.x;
			FP.camera.offset(-FP.halfWidth,0);
		}
	}

}